package uk.ac.leeds.ccg.cluster;
import java.io.*;
import java.awt.*;
import java.awt.event.*;

/** Class: ECellsTimeParametersViewer
 *  Function: To display and modify ECellsTimeParameters
 */
public class ECellsTimeParametersViewer extends TimeParametersViewer implements ActionListener
{
    // Members
    Container ecellsTimeParametersContainer;
    // These Doubles and TextFields allow for the setting of 
    // ECellsTimeParameters from the ECellsTimeParametersViewer

    // Constructors
    public ECellsTimeParametersViewer(TimeParameters p){
	super(p);
    }

    // Methods
    public static void main(String args[])
	throws IOException,FileNotFoundException{
	ECellsTimeParametersViewer ecellsTimeParametersViewer = new ECellsTimeParametersViewer (new ECellsTimeParameters());
	ecellsTimeParametersViewer.run();
    }

    public void run(){
	initComponents();
	setDisplay();
    }

    public void initComponents(){
	// TimeParameters come first as TimeParametersViewer instantiates the 
	// gridBagLayout gridBagLayout and gridBagConstraints gridBagConstraints
	super.initComponents();
	ecellsTimeParametersContainer = new Container();
	ecellsTimeParametersContainer.setLayout(gridBagLayout);
    }

    public void setDisplay(){
	super.setDisplay();
	gridBagConstraints.gridwidth=GridBagConstraints.REMAINDER;
	gridBagLayout.setConstraints(ecellsTimeParametersContainer,gridBagConstraints);
	frame.add(ecellsTimeParametersContainer,frame.getComponentCount());
frame.setTitle("TimeParameters - Empty Cells");
        frame.pack();
    }
    
    public void parseValues(){
	super.parseValues();
    }

    public void setText(){
	super.setText();
    }

    public void actionPerformed(ActionEvent actionEvent){
	String actionCommand = new String(actionEvent.getActionCommand());
	if(actionCommand.equals("load parameters")){
	    System.out.println("Load TimeParameters File");
	    fileDialog = new FileDialog(new Frame());
	    fileFil = new FileFil(fileDialog,".pars");
	    fileDialog.setTitle("Load ECells TimeParameters File");
	    fileDialog.setFilenameFilter(fileFil);
	    fileDialog.setVisible(true);
	    if (fileDialog.getFile()==null) {return;}
	    file = new File(fileDialog.getDirectory(),fileDialog.getFile());
	    try{
		parameters = new ECellsTimeParameters(file);
		setText();
		parseValues();
		//dbase.load(file);
	    }
	    catch(IOException error){
		System.err.println("Error loading file "+error);
		return;
	    }
	}
	else{
	    // This works because calling super.actionPerformed(actionEvent) from this class
	    // uses the methods in this class first if they exist.
	    super.actionPerformed(actionEvent);
	}
    }
}
