package uk.ac.leeds.ccg.cluster;
import java.io.*;
import java.awt.*;
import java.awt.event.*;

/** Class: Knn_STTimeParametersViewer
 *  Function: To display and modify Knn_STTimeParameters
 */
public class Knn_STTimeParametersViewer extends SpaceTimeParametersViewer implements ActionListener
{
    // Members
    Container knn_stTimeParametersContainer;
    // These Doubles and TextFields allow for the setting of 
    // Knn_STTimeParameters from the Knn_STTimeParametersViewer
    Double k;
    TextField kTextField = new TextField(""+((Knn_STTimeParameters)parameters).getK());
  // Constructcts
    public Knn_STTimeParametersViewer(SpaceTimeParameters p){
	super(p);
    }

    // Methods
    public static void main(String args[])
	throws IOException,FileNotFoundException{
	Knn_STTimeParametersViewer knn_stTimeParametersViewer = new Knn_STTimeParametersViewer (new Knn_STTimeParameters());
	knn_stTimeParametersViewer.run();
    }

    public void run(){
	initComponents();
	setDisplay();
    }

    public void initComponents(){
	// SpaceTimeParameters come first as SpaceTimeParametersViewer instantiates the 
	// gridBagLayout gridBagLayout and gridBagConstraints gridBagConstraints
	super.initComponents();
	knn_stTimeParametersContainer = new Container();
	knn_stTimeParametersContainer.setLayout(gridBagLayout);
	// Knn_STTimeParameter k
	label = new Label("Number nearest neighbours");
	gridBagConstraints.anchor=GridBagConstraints.EAST;
	gridBagConstraints.gridwidth=GridBagConstraints.RELATIVE;
	gridBagLayout.setConstraints(label,gridBagConstraints);
	knn_stTimeParametersContainer.add(label);
	kTextField.setText(""+((Knn_STTimeParameters)parameters).getK());
	gridBagConstraints.anchor=GridBagConstraints.WEST;
	gridBagConstraints.gridwidth=GridBagConstraints.REMAINDER;
	gridBagLayout.setConstraints(kTextField,gridBagConstraints);
	knn_stTimeParametersContainer.add(kTextField);
    }

    public void setDisplay(){
	super.setDisplay();
	gridBagConstraints.gridwidth=GridBagConstraints.REMAINDER;
	gridBagLayout.setConstraints(knn_stTimeParametersContainer,gridBagConstraints);
	frame.add(knn_stTimeParametersContainer,frame.getComponentCount());
	frame.setTitle("SpaceTimeParameters - Knn_ST");
        frame.pack();
    }
    
    public void parseValues(){
	super.parseValues();
	k = new Double(kTextField.getText());
	((Knn_STTimeParameters)parameters).setK((int)k.doubleValue());
    }

    public void setText(){
	super.setText();
	kTextField.setText(""+((Knn_STTimeParameters)parameters).getK());
    }

    public void actionPerformed(ActionEvent actionEvent){
	String actionCommand = new String(actionEvent.getActionCommand());
	if(actionCommand.equals("load parameters")){
	    System.out.println("Load SpaceTimeParameters File");
	    fileDialog = new FileDialog(new Frame());
	    fileFil = new FileFil(fileDialog,".pars");
	    fileDialog.setTitle("Load Knn_ST SpaceTimeParameters File");
	    fileDialog.setFilenameFilter(fileFil);
	    fileDialog.setVisible(true);
	    if (fileDialog.getFile()==null) {return;}
	    file = new File(fileDialog.getDirectory(),fileDialog.getFile());
	    try{
		parameters = new Knn_STTimeParameters(file);
		setText();
		parseValues();
		//dbase.load(file);
	    }
	    catch(IOException error){
		System.err.println("Error loading file "+error);
		return;
	    }
	}
	else{
	    // This works because calling super.actionPerformed(actionEvent) from this class
	    // uses the methods in this class first if they exist.
	    super.actionPerformed(actionEvent);
	}
    }
}
