package uk.ac.leeds.ccg.cluster;
// Poisson tests class for cluster methods
// A modification of GamPoissonTest written by J R Davy Jan 1998

//import com.sun.java.util.collections.*;
import java.util.*;

public class PoissonTest extends SignificanceTest implements Constants
{
    double stat = (double) 0.0;
    
    public PoissonTest()
    {
        
        cons = new double[MAXCAN];
        canMax = MAXCAN;
        System.out.println(" *Poisson Test used with MAXIMUM case count of " + MAXCAN);
        for (int i=1; i< MAXCAN; i++)
        {
            cons[i] = ((double) 1.0)/i;
        }
        
    }
    
    
    // public final boolean isSignificant(double sumP, double sumC, MyDouble statis)
    public final boolean isSignificant(Vector points) throws PoissonException
    {
        double totpop = (double) 0.0;
        double totcases = (double) 0.0;
        MyPoint p2;
        
        double  cumPrb[];
        cumPrb = new double[MAXCAN];
        // int jA = (int) sumC;
        // double aMean = (double) sumP;
        double prob;
        
        for(int j=0;j<points.size();j++){
            p2=(MyPoint)points.elementAt(j);
            totpop+=p2.getPop();
            // System.out.println("Pois " +" "+ p2.x +" "+ p2.y +" "+ p2.getPop() +"  "+ p2.getCases());
            totcases+=p2.getCases();
        }
        // System.out.println("Poisson " + totpop +"  "+ totcases);
        // really want something like this, but for the moment cases<1 will suffice!!
        // if(totpop<parameters.getMinPopSize()||totcases<parameters.getMinIncidenceCount()) return false;
        // if(totcases<1) return false;
        int jA = (int) totcases;
        double aMean = (double) totpop;
        
if (!isWorthTesting(totpop, totcases) ) return false;

	try{
    	    if (jA > canMax) throw new PoissonException("Too many cases for a Poisson Test");
	}
	catch(PoissonException e){
	    System.err.println(e.toString() );
	    System.exit(1);
	}

        if (jA > 1)
        {
            cumPrb[0] = Math.exp(-aMean);
            prob = cumPrb[0];
            for(int j=1; j<jA; j++)
            {
                cumPrb[j] = aMean * cons[j] * cumPrb[j-1];
                prob += cumPrb[j];
            }
            prob = 1.0 - prob;
        }
        else
            prob = 1.0 - Math.exp(-aMean);
// System.out.println(prob +" "+ parameters.getSignificanceThreshold() +" "+ totcases +" "+ totpop);
        stat = totcases - totpop;
        if (prob <= parameters.getSignificanceThreshold())
        {
            switch (parameters.getStatType())
            {
                // case 1: stat = sumC - sumP; break;
                // case 2: stat = sumC/sumP;   break;
                case 1: stat = totcases - totpop; break;
                case 2: stat = totcases/totpop;   break;
                case 3: stat = (double) 1.0 - prob;  break;
            }
            //  System.out.println(totpop +"  "+ totcases +"  "+ jA +"  "+ prob +"  "+ stat);
            return true;
        }
        else
            return false;

    }
    
    public double getStatistic(){
        return (double) stat;
    }
    
    public String tostring() {return "Poisson";}
    private int canMax;
    private double cons[];
}

